--[[

--]]

if select(2, UnitClass('player')) ~= "SHAMAN" then
	DisableAddOn("ShockAndAwe_Bars")
	return
end

local L = LibStub("AceLocale-3.0"):GetLocale("ShockAndAwe_Bars")
local AceAddon = LibStub("AceAddon-3.0")
local media = LibStub:GetLibrary("LibSharedMedia-3.0")
ShockAndAwe_Bars = AceAddon:NewAddon("ShockAndAwe_Bars", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
local SCT = SCT
local REVISION = tonumber(("$Revision: 393 $"):match("%d+"))
local _, _, _, clientVersion = GetBuildInfo()
local queryDisable = false

ShockAndAwe_Bars.db = {}
ShockAndAwe_Bars.frames = {}

ShockAndAwe_Bars.textures = {}
ShockAndAwe_Bars.borders = {}
ShockAndAwe_Bars.fonts = {}
ShockAndAwe_Bars.sounds = {}
ShockAndAwe_Bars.barBackdrop = {
		bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = false, tileSize = 0, edgeSize = 12,
		insets = { left = 2, right = 2, top = 2, bottom = 2 }
	}
ShockAndAwe_Bars.frameBackdrop ={
		bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		--edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = false, tileSize = 0, edgeSize = 12,
		insets = { left = 0, right = 0, top = 0, bottom = 0 }
	}
ShockAndAwe_Bars.GCDMin = 0
ShockAndAwe_Bars.GCDMax = 0
ShockAndAwe_Bars.GCDWidth = 0
ShockAndAwe_Bars.GCDID = 61304

local updateActive = {}
	


-----------------------------------------
-- Initialisation & Startup Routines
-----------------------------------------

function ShockAndAwe_Bars:OnInitialize()
	local AceConfigReg = LibStub("AceConfigRegistry-3.0")
	local AceConfigDialog = LibStub("AceConfigDialog-3.0")
	self:SetConstants()
	self:CreateFrames()
	self:SetBindings()
	ShockAndAwe_Bars.defaults = self:SetDefaultOptions()
	
	ShockAndAwe_Bars.db = LibStub("AceDB-3.0"):New("ShockAndAwe_BarsDB", ShockAndAwe_Bars.defaults, "char")
	--self:SetPriorityTable()
	self:GetMSBTAreaDefaults()
	LibStub("AceConfig-3.0"):RegisterOptionsTable("ShockAndAwe_Bars", self:GetOptions(), {"ShockAndAwe_Bars", "saa"} )
	media.RegisterCallback(self, "LibSharedMedia_Registered")
	
	-- Add the options to blizzard frame (add them backwards so they show up in the proper order
	if self.optionsFrame == nil then
		self.optionsFrame = AceConfigDialog:AddToBlizOptions("ShockAndAwe_Bars", "ShockAndAwe_Bars")
	end
	ShockAndAwe_Bars.db:RegisterDefaults(ShockAndAwe_Bars.defaults)
	if not ShockAndAwe_Bars.db.char.immuneTargets then
		ShockAndAwe_Bars.db.char.immuneTargets = {}
	end
	--self:InitialiseUptime()
	self:InitialiseBindings()
	--self:CreateUptimeFrame()
	--self:CreatePriorityFrame()
	self:CreateMsgFrame()
	self:VerifyOptions()
	local version = GetAddOnMetadata("ShockAndAwe_Bars","Version")
	self.version = ("ShockAndAwe_Bars v%s (r%s)"):format(version, REVISION)
	self:Print(self.version.." Loaded.")
end

function ShockAndAwe_Bars:SetConstants()
	ShockAndAwe_Bars.constants = { SpellName = {},
							   SpellID = {},
							   Talents = {},
							   Icons = {},
							   Cooldown = {},
							   FramePercent = {},
							   PowerType = "MAELSTROM",
							   PowerTypeID = 11
							 }

	--core abilities
	self:SetConstant("Cleanse Spirit" , 51886)
	self:SetConstant("Crash Lightning" , 187874)
	self:SetConstant("Dual Wield" , 86629) --passive
	self:SetConstant("Feral Spirit" , 51533)
	self:SetConstant("Flametongue" , 193796)
	self:SetConstant("Frostbrand" , 196834)
	self:SetConstant("Healing Surge" , 188070)
	self:SetConstant("Lava Lash" , 60103)
	self:SetConstant("Lightning Bolt" , 187837)
	self:SetConstant("Maelstrom Controller" , 190899)
	self:SetConstant("Maelstrom Weapon" , 187880) --passive
	self:SetConstant("Rockbiter" , 193786)
	self:SetConstant("Spirit Walk" , 58875)
	self:SetConstant("Stormbringer" , 201845) --passive
	self:SetConstant("Stormlash" , 195255) --passive
	self:SetConstant("Stormstrike" , 17364)
	self:SetConstant("Wind Shear" , 57994)
	self:SetConstant("Windfury" , 33757) --passive
	self:SetConstant("Ancestral Spirit" , 2008)
	
	--talents
	--tier 1
	self:SetTalent("Windsong" , 201898, 1, 1)
	self:SetTalent("Hot Hand" , 201900)
	self:SetTalent("Boulderfist" , 201897)
	--tier 2
	self:SetTalent("Rainfall" , 215864)
	self:SetTalent("Feral Lunge" , 196884)
	self:SetTalent("Wind Rush Totem" , 192077)
	--tier3
	self:SetTalent("Lightning Surge Totem" , 192058)
	self:SetTalent("Earthgrab Totem" , 51485)
	self:SetTalent("Voodoo Totem" , 196932)
	--tier4
	self:SetTalent("Lightning Shield" , 192106)
	self:SetTalent("Ancestral Swiftness" , 192087)
	self:SetTalent("Hailstorm" , 210853)
	--tier5
	self:SetTalent("Tempest" , 192234)
	self:SetTalent("Overcharge" , 210727)
	self:SetTalent("Empowered Stormlash" , 210731)
	--tier6
	self:SetTalent("Crashing Storm" , 192246)
	self:SetTalent("Fury of Air" , 197211)
	self:SetTalent("Sundering" , 197214)
	--tier7
	self:SetTalent("Ascendance" , 114051)
	self:SetTalent("Landslide" , 197992)
	self:SetTalent("Earthen Spike" , 188089)
	
	--boulderfist is not working correctly in API
	--6 sec recharge * 2 charges
	ShockAndAwe_Bars.constants.Cooldown["Boulderfist"] = 6000 * 2
	
	--set frame percentages relative to Stromstrike
	local BaseSize = ShockAndAwe_Bars.constants.Cooldown["Stormstrike"]
	for key,value in pairs(ShockAndAwe_Bars.constants.SpellID)
	do 
		local cd = ShockAndAwe_Bars.constants.Cooldown[key]
		if cd > BaseSize then
			ShockAndAwe_Bars.constants.FramePercent[key] = 1
		else
			ShockAndAwe_Bars.constants.FramePercent[key] = cd / BaseSize
		end		
	end
	
	--hard code some behaviour
	ShockAndAwe_Bars.constants.FramePercent["Energy"] = 1
	ShockAndAwe_Bars.constants.Cooldown["Energy"] = UnitPowerMax("player")
	
end

function ShockAndAwe_Bars:SetConstant(spellName, spellID)
	ShockAndAwe_Bars.constants.SpellID[spellName] = spellID
	ShockAndAwe_Bars.constants.SpellName[spellName], _, ShockAndAwe_Bars.constants.Icons[spellName] = GetSpellInfo(spellID)
	
	ShockAndAwe_Bars.constants.Cooldown[spellName] = GetSpellBaseCooldown(spellID)
	 
end

function ShockAndAwe_Bars:SetTalent(spellName, spellID, row, column)
	self:SetConstant(spellName , spellID);
	ShockAndAwe_Bars.constants.Talents[spellName] = spellID;
	ShockAndAwe_Bars.constants.Talents[spellName.." row"] = row;
	ShockAndAwe_Bars.constants.Talents[spellName.." column"] = column;
end

function ShockAndAwe_Bars:GetTalent(spellName)
	return ShockAndAwe_Bars.constants.Talents[spellName.." row"], ShockAndAwe_Bars.constants.Talents[spellName.." column"];
end

function ShockAndAwe_Bars:TalentKnown(spellName)
	local talentGroup = GetActiveSpecGroup(false,false);
	local row, column = GetTalent(spellName)
	local nameTalent, icon, tier, column, selected, available= GetTalentInfo(row,column,talentGroup);
	
	return selected and (nameTalent == spellName)
end

function ShockAndAwe_Bars:CreateFrames()
	local i
	ShockAndAwe_Bars.BaseFrame = CreateFrame("Frame","ShockAndAwe_BarsBase",UIParent)
	ShockAndAwe_Bars.msgFrame = CreateFrame("MessageFrame","ShockAndAwe_BarsMsg",UIParent)
	ShockAndAwe_Bars.questionFrame = CreateFrame("Frame","ShockAndAwe_BarsQuestion",UIParent)


	i = 1
	ShockAndAwe_Bars.frames["Energy"] = CreateFrame("Frame","SAA_Bar"..i.."_Status", ShockAndAwe_Bars.BaseFrame) 
	ShockAndAwe_Bars.frames["Energy"].icon = CreateFrame("Frame","SAA_Bar"..i.."_StatusIcon",ShockAndAwe_Bars.BaseFrame)
	ShockAndAwe_Bars.frames["Energy"].statusbar = CreateFrame("StatusBar", nil, ShockAndAwe_Bars.frames["Energy"])
	ShockAndAwe_Bars.frames["Energy"].spark = ShockAndAwe_Bars.frames["Energy"].statusbar:CreateTexture(nil, "OVERLAY")
	i = i+1
	for key,value in pairs(ShockAndAwe_Bars.constants.SpellID)
	do 
		ShockAndAwe_Bars.frames[key] = CreateFrame("Frame","SAA_Bar"..i.."_Status", ShockAndAwe_Bars.BaseFrame) 
		ShockAndAwe_Bars.frames[key].icon = CreateFrame("Frame","SAA_Bar"..i.."_StatusIcon",ShockAndAwe_Bars.BaseFrame)
		ShockAndAwe_Bars.frames[key].statusbar = CreateFrame("StatusBar", nil, ShockAndAwe_Bars.frames[key])
		ShockAndAwe_Bars.frames[key].spark = ShockAndAwe_Bars.frames[key].statusbar:CreateTexture(nil, "OVERLAY")
		i = i+1
	end
end

function ShockAndAwe_Bars:OnDisable()
    -- Called when the addon is disabled
	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	self:UnregisterEvent("PLAYER_LOGIN")
	self:UnregisterEvent("PLAYER_ALIVE")
	self:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	--self:UnregisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE")
	self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:UnregisterEvent("UNIT_AURA")
	self:UnregisterEvent("UNIT_MANA")
	self:UnregisterEvent("CHARACTER_POINTS_CHANGED")
	self:UnregisterEvent("PLAYER_REGEN_DISABLED")
	self:UnregisterEvent("PLAYER_REGEN_ENABLED")
	self:UnregisterEvent("PLAYER_TARGET_CHANGED")
	--self:UnregisterEvent("SPELL_UPDATE_COOLDOWN")
	self:UnregisterEvent("UPDATE_BINDINGS")
	self:UnregisterEvent("UI_ERROR_MESSAGE")
-- we must still look out for talent changes to fire change of spec to re-enable
--	self:UnregisterEvent("PLAYER_TALENT_UPDATE")
--	self:UnregisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
	self:UnregisterEvent("UNIT_EXITED_VEHICLE")
	self:UnregisterEvent("UNIT_ENTERED_VEHICLE")
end

function ShockAndAwe_Bars:OnEnable()
	self:LibSharedMedia_Registered()
	self:MyRegisterEvent("PLAYER_ENTERING_WORLD")
	self:MyRegisterEvent("PLAYER_LOGIN")
	self:MyRegisterEvent("PLAYER_ALIVE")
	self:MyRegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	--self:MyRegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE")
	self:MyRegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:MyRegisterEvent("UNIT_AURA")
	self:MyRegisterEvent("UNIT_POWER")
	self:MyRegisterEvent("CHARACTER_POINTS_CHANGED")
	self:MyRegisterEvent("PLAYER_REGEN_DISABLED")
	self:MyRegisterEvent("PLAYER_REGEN_ENABLED")
	self:MyRegisterEvent("PLAYER_TARGET_CHANGED")
	--self:MyRegisterEvent("SPELL_UPDATE_COOLDOWN")
	self:MyRegisterEvent("UPDATE_BINDINGS")
	self:MyRegisterEvent("UI_ERROR_MESSAGE")
	self:MyRegisterEvent("PLAYER_TALENT_UPDATE")
	self:MyRegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
	self:MyRegisterEvent("UNIT_ENTERED_VEHICLE")
	self:MyRegisterEvent("UNIT_EXITED_VEHICLE")
	
	if not (ShockAndAwe_Bars.db.char == nil) then
		if ShockAndAwe_Bars.db.char.disabled then
			self:OnDisable()
		end
	end
end

function ShockAndAwe_Bars:MyRegisterEvent(eventName)
	self:RegisterEvent(eventName,eventName)
end

function ShockAndAwe_Bars:LibSharedMedia_Registered()
	media:Register("sound", "SAA Maelstrom 1", "Sound\\Spells\\ShootWandLaunchLightning.wav")
	media:Register("sound", "SAA Maelstrom 2", "Sound\\Spells\\DynamiteExplode.wav")
	media:Register("sound", "SAA Maelstrom 3", "Sound\\Spells\\ArmorKitBuffSound.wav")
	media:Register("sound", "SAA Maelstrom 4", "Sound\\Spells\\Fizzle\\FizzleShadowA.wav")
	media:Register("sound", "SAA Maelstrom 5", "Sound\\Spells\\LevelUp.wav")
	media:Register("sound", "SAA Maelstrom 6", "Sound\\Spells\\Tradeskills\\FishBite.wav")
	media:Register("sound", "SAA Maelstrom 7", "Sound\\Spells\\Tradeskills\\MiningHitA.wav")
	media:Register("sound", "SAA Maelstrom 8", "Sound\\Spells\\AspectofTheSnake.wav")
	media:Register("sound", "SAA Maelstrom 9", "Sound\\Spells\\bind2_Impact_Base.wav")
	media:Register("sound", "SAA Shield 1", "Sound\\Doodad\\BellowIn.wav")
	media:Register("sound", "SAA Shield 2", "Sound\\Doodad\\BellowOut.wav")
	media:Register("sound", "SAA Shield 3", "Sound\\Doodad\\PVP_Lordaeron_Door_Open.wav")
	media:Register("sound", "SAA Shield 4", "Sound\\Spells\\ShaysBell.wav")

	for k, v in pairs(media:List("statusbar")) do
		self.textures[v] = v
	end
	for k, v in pairs(media:List("border")) do
		self.borders[v] = v
	end
	for k, v in pairs(media:List("font")) do
		self.fonts[v] = v
	end
	for k, v in pairs(media:List("sound")) do
		self.sounds[v] = v
	end
end

----------------------
-- Event Routines
----------------------

function ShockAndAwe_Bars:UNIT_ENTERED_VEHICLE()
	if UnitInVehicle("player") then
		self:TidyUpAfterCombat() -- on entering vehicle treat as if out of combat ie: disable incombat displays
	end	
end

function ShockAndAwe_Bars:UNIT_EXITED_VEHICLE()
	if not UnitInVehicle("player") and InCombatLockdown() then
		self:EnteredCombat()  -- if in combat when exit vehichle enable ShockAndAwe_Bars combat effects
	end
end

function ShockAndAwe_Bars:UNIT_POWER()
	self:UpdateEnergyBar()
end

function ShockAndAwe_Bars:PLAYER_ENTERING_WORLD()
	--if not ShockAndAwe_Bars.db.char == nil then
		self:SetBorderTexture(nil, ShockAndAwe_Bars.db.char.border)
		self:SetBarBorderTexture(nil, ShockAndAwe_Bars.db.char.barborder)
		self:SetTalentEffects()
		self:RedrawFrames()
		self:UpdateBindings()
		--ShockAndAwe_Bars.db.char.priority.prOption = ShockAndAwe_Bars.db.char.priority.prOptions[ShockAndAwe_Bars.db.char.priority.groupnumber]	
	--end
end

function ShockAndAwe_Bars:PLAYER_LOGIN()
	self:SetBorderTexture(nil, ShockAndAwe_Bars.db.char.border)
	self:SetBarBorderTexture(nil, ShockAndAwe_Bars.db.char.barborder)
	self:SetTalentEffects()
	self:RedrawFrames()
	queryDisable = false -- when player first logs in set test for talents in Enh Spec to false
end

function ShockAndAwe_Bars:PLAYER_ALIVE()
	self:SetTalentEffects()
	self:RedrawFrames()
	self:UpdateBindings()
	if not queryDisable then -- only ask if not in Enh and addon active if this is fired immediately after first login
		self:QueryDisableAddon()
		queryDisable = true
	end
end

function ShockAndAwe_Bars:UNIT_AURA(_, ...)
	local arg1 = select(1,...) or ""
	if (arg1 == "player") then
		
	end
end

function ShockAndAwe_Bars:UI_ERROR_MESSAGE(_, ...)
	if ShockAndAwe_Bars.db.char.warning.range then
		local arg1 = select(1,...) or ""
		if strfind(arg1, L["Out of range"]) or strfind(arg1, L["too far away"]) then
			self:PrintMsg(arg1, ShockAndAwe_Bars.db.char.warning.colour, 0.5)
		end
	end
end

function ShockAndAwe_Bars:COMBAT_LOG_EVENT_UNFILTERED(_, timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, ...)
	
	if sourceGUID == UnitGUID("player") then
		local spellID = select(1,...) or 0

		
		if event == "SPELL_AURA_REMOVED" then
			if spellID == ShockAndAwe_Bars.constants.SpellID["Lightning Shield"] or spellID == ShockAndAwe_Bars.constants.SpellID["Water Shield"] then
				if ShockAndAwe_Bars.db.char.warning.shield then
					self:PrintMsg(GetSpellInfo(spellID).." "..L["Expired"], ShockAndAwe_Bars.db.char.warning.colour, ShockAndAwe_Bars.db.char.warning.duration)
					PlaySoundFile(ShockAndAwe_Bars.db.char.shieldsound)
				end
			end
			if GetSpellInfo(spellID) == ShockAndAwe_Bars.constants.SpellName["Ascendance"] then
			  	if ShockAndAwe_Bars.db.char.ssshow then
					-- self.frames["Stormstrike"]:Show()
					self.frames["Stormblast"]:Hide()
					-- self.frames["Stormstrike"].icon:Show()
					self.frames["Stormblast"].icon:Hide()
				end
			end
		end
		if ShockAndAwe_Bars.db.char.warning.interrupt and event == "SPELL_INTERRUPT" then
			local spellName = select(5,...)
			if spellName then
				self:PrintMsg(L["Interrupted: "] .. spellName, ShockAndAwe_Bars.db.char.warning.colour, ShockAndAwe_Bars.db.char.warning.duration)
			end
		end
		if ShockAndAwe_Bars.db.char.warning.purge and event == "SPELL_DISPEL"  and spellID == ShockAndAwe_Bars.constants.SpellID["Purge"] then
			local spellName = select(5,...)
			if spellName then
				self:PrintMsg(L["Purged: "] .. spellName, ShockAndAwe_Bars.db.char.warning.colour, ShockAndAwe_Bars.db.char.warning.duration)
			end
		end
		if event == "SPELL_MISSED" then
			local missType = select(4, ...) or ""
			if missType == "IMMUNE" then
				local spellName = select(2, ...) or ""
				ShockAndAwe_Bars.db.char.immuneTargets[destName.."_"..spellName] = true
			end
		end
		if event == "SPELL_DAMAGE" then
			local spellName = select(2, ...) or ""
			if ShockAndAwe_Bars.db.char.immuneTargets[destName.."_"..spellName] then
				-- clear immunity if we managed to damage target with this spell - ie: it was a temporary immunity
				ShockAndAwe_Bars.db.char.immuneTargets[destName.."_"..spellName] = nil
			end
		end		
	end
end


function ShockAndAwe_Bars:UNIT_SPELLCAST_SUCCEEDED(_, ...)
	local spellCaster = select(1,...) or ""
	local spellName = select(2,...) or ""
	if spellCaster == "player" then -- skip if someone else casting
	
		if ShockAndAwe_Bars:IsBarEnabled(spellName) then			
				self:ActivateBar(spellName, ShockAndAwe_Bars.db.char.colours[spellName])			
		end
		
	end
end

function ShockAndAwe_Bars:CHARACTER_POINTS_CHANGED()
	self:SetTalentEffects()
end

function ShockAndAwe_Bars:PLAYER_REGEN_DISABLED() -- Entering Combat
	self:EnteredCombat()
end

function ShockAndAwe_Bars:PLAYER_REGEN_ENABLED() -- Leaving Combat
	self:TidyUpAfterCombat()
end

function ShockAndAwe_Bars:PLAYER_TARGET_CHANGED()
	--if ShockAndAwe_Bars.db.char.priority.show and InCombatLockdown() then
	--	self:FlameShockDotBar(false) -- force update on FS dot bar after target change
	--	self:SetNextPriority()
	--end
end

function ShockAndAwe_Bars:UPDATE_BINDINGS()
	if not InCombatLockdown() then
		self:UpdateBindings()
	end
end

function ShockAndAwe_Bars:PLAYER_TALENT_UPDATE()
	self:SetTalentEffects()
	self:RedrawFrames()
end

function ShockAndAwe_Bars:ACTIVE_TALENT_GROUP_CHANGED(index)
	self:SetTalentEffects()
	self:RedrawFrames()
	self:QuerySpecChanged()
end

----------------------------
-- Combat start and stop
----------------------------

function ShockAndAwe_Bars:EnteredCombat()
	if UnitInVehicle("player") then -- don't enable priorities & bars if we enter combat in a vehicle
		return
	end
	if GetSpecialization() ~= 2 then -- check MW talents again to counter Player_Entering_World bug
		self:SetTalentEffects()
		--self:SetupBaseFrame()
		self:RedrawFrames()
	end
	
	if ShockAndAwe_Bars.db.char.disablebars then
		self.BaseFrame:Show()
	end
	if ShockAndAwe_Bars.db.char.bars["Energy"].Enabled then
		self:UpdateEnergyBar()
		self:ActivateEnergyBar()
	end
	
	for key,value in pairs(updateActive)
	do
		if not (value == nil) then
			self.frames[key]:Show()
			self.frames[key].spark:Show()
			
			if ShockAndAwe_Bars.db.char.showicons then			
				self.frames[key].icon:Show()			
			end
		end
	end
	
end

function ShockAndAwe_Bars:TidyUpAfterCombat()
	if ShockAndAwe_Bars.db.char.bars["Energy"].Enabled then
		self.frames["Energy"]:Hide()
		self.frames["Energy"].spark:Hide()
		self.frames["Energy"].spark2:Hide()
		self.frames["Energy"].icon:Hide()
	end
	for key,value in pairs(updateActive)
	do
		if not (value == nil) then
			self.frames[key]:Hide()
			self.frames[key].spark:Hide()
			self.frames[key].icon:Hide()
		end
	end
	
	
	if ShockAndAwe_Bars.db.char.disablebars then
		self.BaseFrame:Hide()
	end
	if not ShockAndAwe_Bars.db.char.binding.macroset then
		-- call update Bindings to set macro keys if we were in combat when addon initialised
		self:UpdateBindings()
	end
	--collectgarbage()
end

----------------------------
-- Question box handler
----------------------------

function ShockAndAwe_Bars:QuerySpecChanged()
	if ShockAndAwe_Bars.db.char.specchangewarning then
		if GetSpecialization() ~= 2 and not ShockAndAwe_Bars.db.char.disabled then
			-- addon is enabled but we have changed to a non Enhance Spec ask if we should disable addon
			self:DisplayQuestionFrame(false, true)
		elseif GetSpecialization() == 2 and ShockAndAwe_Bars.db.char.disabled then
			-- addon is disabled and we have changed to an Enhance Spec ask if we should enable addon
			self:DisplayQuestionFrame(true, true)
		end
	end
end

function ShockAndAwe_Bars:QueryDisableAddon()
	if GetSpecialization() ~= 2 then -- check MW talents again to counter Player_Entering_World bug
		self:SetTalentEffects()
	end
	if UnitLevel("player") >= 60 then -- don't bother asking to disable addon if player under level 60.
		if GetSpecialization() ~= 2 and not ShockAndAwe_Bars.db.char.disabled then
			-- addon is enabled but we have changed to a non Enhance Spec ask if we should disable addon
			self:DisplayQuestionFrame(false, false)
		elseif GetSpecialization() == 2 and ShockAndAwe_Bars.db.char.disabled then
			-- addon is disabled and we have changed to an Enhance Spec ask if we should enable addon
			self:DisplayQuestionFrame(true, false)
		end
	end
end

StaticPopupDialogs["SAA_QUESTION_FRAME"] = {
	text = L["You have changed to a new talent spec do you want to enable ShockAndAwe_Bars?"],
	button1 = "Yes",
	button2 = "No",
	OnAccept = function()
		ShockAndAwe_Bars:EnableDisable()
	end,
	timeout = 0,
	hideOnEscape = 1,
}

function ShockAndAwe_Bars:DisplayQuestionFrame(enable, spec)
	if spec then
		if enable then 
			StaticPopupDialogs["SAA_QUESTION_FRAME"].text = L["You have changed to a new talent spec do you want to enable ShockAndAwe_Bars?"]
		else
			StaticPopupDialogs["SAA_QUESTION_FRAME"].text = L["You have changed to a new talent spec do you want to disable ShockAndAwe_Bars?"]
		end
	else
		if enable then 
			StaticPopupDialogs["SAA_QUESTION_FRAME"].text = L["You are in Enhancement spec do you want to enable ShockAndAwe_Bars?"]
		else
			StaticPopupDialogs["SAA_QUESTION_FRAME"].text = L["You are NOT in Enhancement spec do you want to disable ShockAndAwe_Bars?"]
		end
	end
	self:DebugPrint("entered DisplayQuestionFrame, text is :"..StaticPopupDialogs["SAA_QUESTION_FRAME"].text)
	StaticPopup_Show("SAA_QUESTION_FRAME")
end
	
-------------------------
-- Shield bar routines
-------------------------

function ShockAndAwe_Bars:GetShieldInfo()
	local index = 1
	ShieldTime = 0
	while UnitBuff("PLAYER", index) do
		local name, _, _, count, _, _, shieldExpires = UnitBuff("PLAYER", index)
		ShieldTime = shieldExpires
		if self:SetShieldType(name) then
		    	count = 1 -- shields no longer have charges
			
			return count, name, shieldExpires
		end
		index = index + 1
	end
	return 0, "", 0
end

function ShockAndAwe_Bars:SetShieldType(name)
	local colours = ShockAndAwe_Bars.db.char.colours;
	if name == ShockAndAwe_Bars.constants.SpellName["Lightning Shield"] then
		self:ShieldBar(colours.lightningshield.r, colours.lightningshield.g, colours.lightningshield.b, colours.lightningshield.a)
		self:SetBarIcon(self.frames["Lightning Shield"].icon, ShockAndAwe_Bars.constants.Icons["Lightning Shield"])
		return true
	end
	return false
end	


---------------------------
-- Buff Info functions
---------------------------

---------------------------
-- functions
---------------------------

function ShockAndAwe_Bars:EnablePetFrame()
	if not oldHasPetUI then 
		oldHasPetUI = HasPetUI; 
		HasPetUI = function() 
			return true, false; 
		end
	end
	--PetTab_Update() 
	ToggleCharacter("PetPaperDollFrame")
end

function ShockAndAwe_Bars:RedrawFrames()
	self:SetupBaseFrame()
	self:SetupEnergyBar()
end

function ShockAndAwe_Bars:SetTalentEffects()
	ShockAndAwe_Bars.db.char.SSMaxCharge = 1
	
	
	--ShockAndAwe_Bars.db.char.maxLen = self.constants.Cooldown["Stormstrike"]
	
	--self:RedrawFrames()
	
	
end

function ShockAndAwe_Bars:DisplayVersion()
	self:Print(self.version)
end

function ShockAndAwe_Bars:SetupBaseFrame()
	
	self.BaseFrame:SetScale(ShockAndAwe_Bars.db.char.scale)
	self.BaseFrame:SetFrameStrata("BACKGROUND")
	self.BaseFrame:SetWidth(ShockAndAwe_Bars.db.char.fWidth + ShockAndAwe_Bars.db.char.fHeight / 7)
	self.BaseFrame:SetHeight(ShockAndAwe_Bars.db.char.fHeight)
	self.BaseFrame:SetBackdrop(self.frameBackdrop)
	self.BaseFrame:SetBackdropColor(1, 1, 1, 0)
	self.BaseFrame:SetMovable(true)
	self.BaseFrame:RegisterForDrag("LeftButton")
	self.BaseFrame:SetPoint(ShockAndAwe_Bars.db.char.point, ShockAndAwe_Bars.db.char.relativeTo, ShockAndAwe_Bars.db.char.relativePoint, ShockAndAwe_Bars.db.char.xOffset, ShockAndAwe_Bars.db.char.yOffset)
	self.BaseFrame:SetScript("OnDragStart", 
		function()
			self.BaseFrame:StartMoving();
		end );
	self.BaseFrame:SetScript("OnDragStop",
		function()
			self.BaseFrame:StopMovingOrSizing();
			self.BaseFrame:SetScript("OnUpdate", nil);
			self:FinishedMoving(ShockAndAwe_Bars.db.char, self.BaseFrame);
		end );
	self.BaseFrame:Show()
	ShockAndAwe_Bars.db.char.movingframes = false
	
	local barHeight = ShockAndAwe_Bars.db.char.fHeight / 7
	local baseOffset = (-1 * barHeight) + 3
	
	local barCount = 1
	
	
	if ShockAndAwe_Bars.db.char.bars["Energy"].Enabled then
		ShockAndAwe_Bars:EasySetBarFrame("Energy", ShockAndAwe_Bars.db.char.colours["Energy"], barCount)
		barCount = barCount + 1
	end
	
	
	for key,value in pairs(ShockAndAwe_Bars.db.char.bars)
	do
		if not (key == "Energy") then
			if value.Enabled then
				ShockAndAwe_Bars:EasySetBarFrame(key, ShockAndAwe_Bars.db.char.colours[key], barCount)
				barCount = barCount + 1 
			end
		end
	end
	
end

function ShockAndAwe_Bars:EasySetBarFrame(barName, colours, barCount)
	local barHeight = ShockAndAwe_Bars.db.char.fHeight / 7
	local baseOffset = (-1 * barHeight) + 3
	
	ShockAndAwe_Bars:SetBarFrame(
					self.frames[barName], 
					ShockAndAwe_Bars.db.char.fWidth * ShockAndAwe_Bars.constants.FramePercent[barName],
					barHeight, 
					barCount * baseOffset, 
					2,
					0, 
					self.constants.Cooldown[barName], 
					0.4, 
					0.4,
					colours.r, colours.g, colours.b, colours.a,
					true)
					
	self:SetBarIcon(self.frames[barName].icon, ShockAndAwe_Bars.constants.Icons[barName])
end

function ShockAndAwe_Bars:SetBarFrame(frame, barWidth, barHeight, frameOffset, frameLevel, minValue, maxValue, frameValue, frameSpark, frameR, frameG, frameB, frameAlpha, icon)
	frame:SetFrameStrata("LOW")
	frame:SetWidth(barWidth) 
	frame:SetHeight(barHeight)
	frame:ClearAllPoints()
	frame:SetPoint("TOPLEFT", self.BaseFrame, "TOPLEFT", barHeight, frameOffset)
	frame:SetBackdrop(self.barBackdrop);
	frame:SetBackdropColor(0, 0, 0, .2);
	frame:SetBackdropBorderColor( 1, 1, 1, 1);
	frame:EnableMouse(false)
	if not frame.statusbar then
		frame.statusbar = CreateFrame("StatusBar", nil, frame)
	end
	frame.statusbar:SetFrameLevel(frameLevel)
	frame.statusbar:ClearAllPoints()
	frame.statusbar:SetHeight(barHeight - 6)
	frame.statusbar:SetWidth(barWidth - 6)
	frame.statusbar:SetPoint("TOPLEFT", frame, "TOPLEFT", 3, -3)
	frame.statusbar:SetStatusBarTexture(media:Fetch("statusbar", ShockAndAwe_Bars.db.char.texture))
	frame.statusbar:GetStatusBarTexture():SetHorizTile(false) -- fix for textures stretching rather than revealing
	frame.statusbar:SetStatusBarColor(frameR, frameG, frameB, frameAlpha)
	frame.statusbar:SetMinMaxValues(minValue,maxValue)
	frame.statusbar:SetValue(frameValue)
	
	if not frame.spark then
		frame.spark = frame.statusbar:CreateTexture(nil, "OVERLAY")
	end
	frame.spark:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
	frame.spark:SetWidth(16)
	frame.spark:SetHeight(barHeight + 16)
	frame.spark:SetBlendMode("ADD")
	--frame.spark:SetPoint("CENTER",frame.statusbar,"LEFT",(barWidth - 6)* frameSpark, -1)
	--frame.spark:Show()
	
	if not frame.spark2 then
		frame.spark2 = frame.statusbar:CreateTexture(nil, "OVERLAY")
	end
	frame.spark2:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
	frame.spark2:SetWidth(16)
	frame.spark2:SetHeight(barHeight + 16)
	frame.spark2:SetBlendMode("ADD")
	--frame.spark2:SetPoint("CENTER",frame.statusbar,"LEFT",(barWidth - 6)* frameSpark, -1)
	--frame.spark2:Hide()
	
	if not frame.text then
		frame.text = frame:CreateFontString(nil,"OVERLAY")
	end
	local barfont = media:Fetch("font", ShockAndAwe_Bars.db.char.barfont)
	frame.text:SetFont(barfont, ShockAndAwe_Bars.db.char.barfontsize, ShockAndAwe_Bars.db.char.barfonteffect)
	frame.text:ClearAllPoints()
	frame.text:SetTextColor(1, 1, 1, 1)
	frame.text:SetPoint("CENTER", frame, "CENTER");
	frame.text:SetText("")

	frame:SetScript("OnUpdate", 
		function()
			ShockAndAwe_Bars:OnBarUpdate();
		end );
	if icon then
		frame.icon:SetWidth(barHeight - 3) -- same as height to get square box
		frame.icon:SetHeight(barHeight - 3)
		frame.icon:SetPoint("TOPRIGHT", frame, "TOPLEFT", 0 , -2)
		frame.icon:Hide()
	end	
	frame:Hide()
end

function ShockAndAwe_Bars:SetBarIcon(iconFrame, icon)	
	if not iconFrame.texture then
		iconFrame.texture = iconFrame:CreateTexture()
		iconFrame.texture:SetAllPoints()
	end
	iconFrame.texture:SetTexture(icon)
	
end

function ShockAndAwe_Bars:getFSDotDuration()
	local numglyphs = GetNumGlyphSockets()
	local fnGlyph = false
	for index = 1, numglyphs do
		local _, _, _, spellID = GetGlyphSocketInfo(index)
		if spellID == 55447 then
			fnGlyph = true
		end
	end
	if fnGlyph then 
		return 30
	else
		return 24
	end
end

function ShockAndAwe_Bars:ResetBars()
	self.BaseFrame:ClearAllPoints()
	ShockAndAwe_Bars.db.char.point = self.defaults.char.point
	ShockAndAwe_Bars.db.char.relativeTo = self.defaults.char.relativeTo 
	ShockAndAwe_Bars.db.char.relativePoint = self.defaults.char.relativePoint
	ShockAndAwe_Bars.db.char.xOffset = self.defaults.char.xOffset
	ShockAndAwe_Bars.db.char.yOffset = self.defaults.char.yOffset
	ShockAndAwe_Bars.db.char.fWidth = self.defaults.char.fWidth
	ShockAndAwe_Bars.db.char.fHeight = self.defaults.char.fHeight
	ShockAndAwe_Bars.db.char.scale = self.defaults.char.scale
	ShockAndAwe_Bars.db.char.barfont = self.defaults.char.barfont
	ShockAndAwe_Bars.db.char.barfontsize = self.defaults.char.barfontsize
	ShockAndAwe_Bars.db.char.bartexture = self.defaults.char.bartexture
	ShockAndAwe_Bars.db.char.texture = self.defaults.char.texture
	self.BaseFrame:SetPoint(ShockAndAwe_Bars.db.char.point, ShockAndAwe_Bars.db.char.relativeTo, ShockAndAwe_Bars.db.char.relativePoint, ShockAndAwe_Bars.db.char.xOffset, ShockAndAwe_Bars.db.char.yOffset)
	ShockAndAwe_Bars:SetTalentEffects()
	self:RedrawFrames()
	ShockAndAwe_Bars.db.char.movingframes = true -- so that call to ShowHideBars resets to false
	self:ShowHideBars()
	self:Print(L["config_reset"])
end

function ShockAndAwe_Bars:DebugTalents()
	local numTabs = GetNumTalentTabs();
	for t=1, numTabs do
		DEFAULT_CHAT_FRAME:AddMessage(GetTalentTabInfo(t)..":");
		local numTalents = GetNumTalents(t);
		for i=1, numTalents do
			nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(t,i);
			DEFAULT_CHAT_FRAME:AddMessage("- "..i..":"..nameTalent..": "..currRank.."/"..maxRank);
		end
	end
end

function ShockAndAwe_Bars:DebugFrameValues()
	self:Print("SSlen : "..ShockAndAwe_Bars.db.char.SSlen)
	self:Print("SSPercent : "..ShockAndAwe_Bars.db.char.SSPercent )
	self:Print("ShockLen : "..ShockAndAwe_Bars.db.char.ShockLen)
	self:Print("ShockPercent : "..ShockAndAwe_Bars.db.char.ShockPercent )
	self:Print("WFProcPercent : "..ShockAndAwe_Bars.db.char.WFProcPercent)
end


function ShockAndAwe_Bars:ActivateEnergyBar()
	if ShockAndAwe_Bars.db.char.bars["Energy"].Enabled and not ShockAndAwe_Bars.db.char.disabled then
		self.frames["Energy"].spark:Show()
		self.frames["Energy"].spark2:Show()
		self.frames["Energy"]:Show()
		if ShockAndAwe_Bars.db.char.showicons then
			self.frames["Energy"].icon:Show()
		else
			self.frames["Energy"].icon:Hide()
		end
	end	
end

function ShockAndAwe_Bars:UpdateEnergyBar()
	if ShockAndAwe_Bars.db.char.bars["Energy"].Enabled then
		power = UnitPower("player", ShockAndAwe_Bars.constants.PowerTypeID)
		self.frames["Energy"].statusbar:SetValue(power)
	end
end

function ShockAndAwe_Bars:SetupEnergyBar()
	if ShockAndAwe_Bars.db.char.bars["Energy"].Enabled then
	
		local maxPower = UnitPowerMax("player" , ShockAndAwe_Bars.constants.PowerTypeID)
		local minPower, _ = self.frames["Energy"].statusbar:GetMinMaxValues()
		local frame = self.frames["Energy"]
		local _, _, frameWidth, _ = frame:GetBoundsRect()
		
		ShockAndAwe_Bars.constants.Cooldown["Energy"] = maxPower
		
		frame.statusbar:SetMinMaxValues(minPower,maxPower)
		frame.spark:SetPoint("CENTER", frame.statusbar,"LEFT", ShockAndAwe_Bars.db.char.maelstromLow / maxPower * frameWidth ,-1)
		frame.spark2:SetPoint("CENTER", frame.statusbar,"LEFT", ShockAndAwe_Bars.db.char.maelstromHigh / maxPower * frameWidth ,-1)
	end
	

end

function ShockAndAwe_Bars:ActivateBar(spellName, colours)
	
	self.frames[spellName].statusbar:SetStatusBarColor(colours.r, colours.g, colours.b, colours.a)
	self.frames[spellName]:Show()

	self:DebugPrint("Activate Bar :"..spellName)
	if ShockAndAwe_Bars.db.char.showicons then
		self.frames[spellName].icon:Show()
	else
		self.frames[spellName].icon:Hide()
	end
	
	updateActive[spellName] = true;
end



function ShockAndAwe_Bars:DebugDebuffInfo()
	local index = 1
	while UnitDebuff("target", index) do
		local name, _, _, count, _, _, debuffExpires, unitCaster = UnitDebuff("target", index)
		local isMine = unitCaster == "player" 
		local expires = debuffExpires-GetTime()
		if isMine then
			self:DebugPrint("Debuff :"..name.." expires:"..expires)
		end
		index = index + 1
	end
end


local OBU = {}

function ShockAndAwe_Bars:OnBarUpdate()
	if ShockAndAwe_Bars.db.char.disabled then
		return
	end
	
	OBU.width = ShockAndAwe_Bars.db.char.fWidth - 6
	OBU.timeLeft = 0
	
	for key,value in pairs(updateActive)
	do

		if not (value == nil) then
			self:UpdateMultiChargeFrame(key)
		end
	end
	
		
end

function ShockAndAwe_Bars:UpdateMultiChargeFrame(spellName)
	local currentCharges, maxCharge, cooldownStart, CDlen
	local frame, frameMin, frameMax, frameWidth, spellID
	
	frame = self.frames[spellName]
	spellID = self.constants.SpellID[spellName]
	
	--_, _, frameWidth, _ = frame.statusbar:GetBoundsRect()
	frameWidth = GetBarWidth(spellName)
	
	frameMin, frameMax = frame.statusbar:GetMinMaxValues()
	
	currentCharges, maxCharge , cooldownStart, CDlen = GetSpellCharges(spellID)
	if currentCharges == nil then
		maxCharge = 1
		cooldownStart, CDlen, _ = GetSpellCooldown(spellID)
		
		if CDlen == 0 then
			currentCharges = 1
		else
			currentCharges = 0
		end
		
	end
	
	--CDLen = seconds
	--cooldownStart = seconds
	--GetTime = seconds
		
	OBU.timeLeftFirst = (cooldownStart + CDlen - GetTime() ) * 1000
	if maxCharge > 1 and currentCharges == 0 then
		OBU.timeLeftAdditional = CDlen * 1000
		frame.spark2:Show()
	else
		OBU.timeLeftAdditional = 0
		if not (frame.spark2 == nil) then
			frame.spark2:Hide()
		end
	end
		
	OBU.timeLeft = math.min((OBU.timeLeftFirst + OBU.timeLeftAdditional) , frameMax)
	
	
	
	frame.statusbar:SetValue(OBU.timeLeft)
	frame.spark:SetPoint("CENTER", frame.statusbar,"LEFT", OBU.timeLeft/ frameMax * frameWidth ,-1)
	frame.spark2:SetPoint("CENTER", frame.statusbar,"LEFT", OBU.timeLeftAdditional / frameMax * frameWidth ,-1)
	
	
	
	if currentCharges == maxCharge then
		frame:Hide()
		frame.icon:Hide()
		updateActive[spellName] = nil;
		return false
	end
	
	return true
end

function GetBarWidth(barName)
	return ShockAndAwe_Bars.db.char.fWidth * ShockAndAwe_Bars.constants.FramePercent[barName]
end

function ShockAndAwe_Bars:CreateMsgFrame()
	self.msgFrame:ClearAllPoints()
	self.msgFrame:SetWidth(400)
	self.msgFrame:SetHeight(75)
	self.msgFrame:SetFrameStrata("BACKGROUND")
	self.msgFrame:SetBackdrop({
		bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		--edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = false, tileSize = 0, edgeSize = 12,
		insets = { left = 2, right = 2, top = 2, bottom = 2 }
	})
	self.msgFrame:SetBackdropColor(1, 1, 1, 0)
	self.msgFrame:SetMovable(true)
	self.msgFrame:RegisterForDrag("LeftButton")
	self.msgFrame:SetScript("OnDragStart", 
		function()
			self.msgFrame:StartMoving();
		end );
	self.msgFrame:SetScript("OnDragStop",
		function()
			self.msgFrame:StopMovingOrSizing();
			self.msgFrame:SetScript("OnUpdate", nil);
			self:FinishedMoving(ShockAndAwe_Bars.db.char.warning, self.msgFrame);
		end );
	self.msgFrame:SetPoint(ShockAndAwe_Bars.db.char.warning.point, ShockAndAwe_Bars.db.char.warning.relativeTo, ShockAndAwe_Bars.db.char.warning.relativePoint, ShockAndAwe_Bars.db.char.warning.xOffset, ShockAndAwe_Bars.db.char.warning.yOffset)
	self.msgFrame:SetInsertMode("TOP")
	self.msgFrame:SetFrameStrata("HIGH")
	self.msgFrame:SetToplevel(true)
	local font = media:Fetch("font", ShockAndAwe_Bars.db.char.msgfont)
	self.msgFrame:SetFont(font, ShockAndAwe_Bars.db.char.msgfontsize, ShockAndAwe_Bars.db.char.msgfonteffect)
		
	self.msgFrame:Show()
end

function ShockAndAwe_Bars:PrintMsg(msg, col, time)
	if ShockAndAwe_Bars.db.char.warning.show and not ShockAndAwe_Bars.db.char.disabled then
		if col == nil then
			col = { r=1, b=1, g=1, a=1 }
		end
		if time == nil then 
			time = 3
		end
		if time ~= 5 then
			self.msgFrame:SetTimeVisible(time)
		end
		self.msgFrame:AddMessage(msg, col.r, col.g, col.b, 1, col.time)
	end
end

function ShockAndAwe_Bars:DebugPrint(msg)
	if ShockAndAwe_Bars.db.char.debug then
		self:Print(msg)
	end
end

